; asmsyntax=fasm

; old algo:
; var1=(((base_damage*dam_mult/dam_div)/2)*cbt_diff_mod)/100-dmg_tresh
; final=var1-(var1*ammo_dr_adj)/100

;(((base_damage*dam_mult/dam_div)/2)*cbt_diff_mod)/100-dmg_tresh-(((((base_damage*dam_mult/dam_div)/2)/cbt_diff_mod)/100-dmg_tresh)*(ammo_dr_adj+dmg_resist)/100 

; new algo
; var1=(((base_damage*dam_mult)/2)*cbt_diff_mod)/100-dmg_tresh/dam_div
; final=var1-(var1*ammo_dr_adj)/100

;(((base_damage*dam_mult)/2)*cbt_diff_mod)/100-dmg_tresh/dam_div-(((((base_damage*dam_mult)/2)/cbt_diff_mod)/100-dmg_tresh/dam_div)*(ammo_dr_adj+dmg_resist)/100)

random_damage=0x478448
bonus_ranged=-0x1C
dam_mult=-0x10
cbt_diff_mod=-0x14
dmg_tresh=-0xC
dr_adjust=-0x8
var_4=-0x4
nbhit=-0x18

org	0x4249EC

use32

cumuldamages:
mov	edx,	[esi+4]
mov	eax,	[esi]
mov	ebx,	[esp+0x34+bonus_ranged]
call	random_damage
add	ebx,	eax			; damages=random_damages+bonus_ranged
imul	ebx,	[esp+0x34+dam_mult]	; damages*=dam_mult
sar	ebx,	1			; damages/=2
imul	ebx,	[esp+0x34+cbt_diff_mod]	; damages*=cbt_diff_mod
mov	eax,	100
xchg	eax,	ebx
cdq
idiv	ebx				; damages/=100
mov	ebx,	eax
test	ebp,	ebp			; no division by zero
jz	@f

mov	eax,	[esp+0x34+dmg_tresh]
cdq
idiv	ebp				; dmg_tresh/dam_div
sub	ebx,	eax			; damages-=dmg_tresh/dam_div

@@:
test	ebx,	ebx
jle	@f

mov	eax,	ebx			; damages2=damages
imul	dword [esp+0x34+dr_adjust]	; damages2*=dr_adjust
mov	dword [esp+0x34+var_4],	100
idiv	dword [esp+0x34+var_4]		; damages2/=100
sub	ebx,	eax			; damages-=damages2
test	ebx,	ebx
jle	@f

add	[edi],	ebx			; total+=damages

@@:
mov	eax,	[esp+34h+nbhit]
inc	ecx
cmp	ecx,	eax
jl	cumuldamages
jmp	0x424A63

;BEGTEXT:004249EC cumuldamages:                           ; CODE XREF: damages_computation+2A9j
;BEGTEXT:004249EC                 mov     edx, [attack_data+4]
;BEGTEXT:004249EF                 mov     eax, [attack_data+Attack_data.who]
;BEGTEXT:004249F1                 mov     ebx, [esp+34h+bonus_ranged]
;BEGTEXT:004249F5                 call    random_damage   ; input:
;BEGTEXT:004249F5                                         ; eax: who
;BEGTEXT:004249F5                                         ; edx: ?
;BEGTEXT:004249F5                                         ; output:
;BEGTEXT:004249F5                                         ; eax: damages in weapon range
;BEGTEXT:004249FA                 add     ebx, eax        ; damages=random_damage+bonus_ranged
;BEGTEXT:004249FC                 imul    ebx, [esp+34h+dam_mult] ; damages*=dam_mult
;BEGTEXT:00424A01                 test    ebp, ebp
;BEGTEXT:00424A03                 jz      short loc_424A10
;BEGTEXT:00424A05                 mov     edx, ebx
;BEGTEXT:00424A07                 mov     eax, ebx
;BEGTEXT:00424A09                 sar     edx, 31
;BEGTEXT:00424A0C                 idiv    ebp             ; damages/=dam_div
;BEGTEXT:00424A0E                 mov     ebx, eax
;BEGTEXT:00424A10
;BEGTEXT:00424A10 loc_424A10:                             ; CODE XREF: damages_computation+24Bj
;BEGTEXT:00424A10                 mov     edx, ebx
;BEGTEXT:00424A12                 mov     eax, ebx
;BEGTEXT:00424A14                 sar     edx, 31
;BEGTEXT:00424A17                 sub     eax, edx
;BEGTEXT:00424A19                 sar     eax, 1          ; damages/=2
;BEGTEXT:00424A1B                 mov     edx, [esp+34h+cbt_diff_mod]
;BEGTEXT:00424A1F                 imul    edx, eax        ; damages*=cbt_diff_mod
;BEGTEXT:00424A22                 mov     ebx, 100
;BEGTEXT:00424A27                 mov     eax, edx
;BEGTEXT:00424A29                 sar     edx, 31
;BEGTEXT:00424A2C                 idiv    ebx             ; damages/=100
;BEGTEXT:00424A2E                 mov     edx, [esp+34h+dmg_tresh]
;BEGTEXT:00424A32                 mov     ebx, eax
;BEGTEXT:00424A34                 sub     ebx, edx        ; damages-=dmg_tresh
;BEGTEXT:00424A36                 test    ebx, ebx
;BEGTEXT:00424A38                 jle     short loc_424A54
;BEGTEXT:00424A3A                 mov     edx, [esp+34h+ammo_dr_adj]
;BEGTEXT:00424A3E                 imul    edx, ebx        ; damages2=damages*ammo_dr_adj
;BEGTEXT:00424A41                 mov     [esp+34h+var_4], 100
;BEGTEXT:00424A49                 mov     eax, edx
;BEGTEXT:00424A4B                 sar     edx, 31
;BEGTEXT:00424A4E                 idiv    [esp+34h+var_4] ; damages2/=100
;BEGTEXT:00424A52                 sub     ebx, eax
;BEGTEXT:00424A54
;BEGTEXT:00424A54 loc_424A54:                             ; CODE XREF: damages_computation+280j
;BEGTEXT:00424A54                 test    ebx, ebx        ; damages-=damages2
;BEGTEXT:00424A56                 jle     short loc_424A5A
;BEGTEXT:00424A58                 add     [damages], ebx
;BEGTEXT:00424A5A
;BEGTEXT:00424A5A loc_424A5A:                             ; CODE XREF: damages_computation+29Ej
;BEGTEXT:00424A5A                 mov     eax, [esp+34h+nbhit]
;BEGTEXT:00424A5E                 inc     ecx
;BEGTEXT:00424A5F                 cmp     ecx, eax
;BEGTEXT:00424A61                 jl      short cumuldamages

